#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Collections::Generic;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::IO;

#include "NitroROM.h"
#include "NitroOverlay.h"

#include "leveldata.h"

#include "EditorMainForm.h"


namespace sm64ds_editor
{

	/// <summary>
	/// Description rsume de Form1
	///
	/// AVERTISSEMENT: si vous modifiez le nom de cette classe, vous devrez modifier la
	///          proprit 'Nom du fichier de ressources' de l'outil de compilation de ressource manage
	///          pour tous les fichiers .resx dont dpend cette classe. Dans le cas contraire,
	///          les concepteurs ne pourront pas interagir correctement avec les ressources
	///          localises associes  ce formulaire.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ajoutez ici le code du constructeur
			//
		}

	protected:
		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::ToolStrip^  toolStrip1;
	private: System::Windows::Forms::ListBox^  lbxLevels;

	private: System::Windows::Forms::ToolStripButton^  btnOpenROM;
	private: System::Windows::Forms::OpenFileDialog^  rompicker;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;
	private: System::Windows::Forms::ToolStripButton^  btnOpenLevel;
	private: System::Windows::Forms::SaveFileDialog^  rombackup;

	protected: 

	private:
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->toolStrip1 = (gcnew System::Windows::Forms::ToolStrip());
			this->btnOpenROM = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->btnOpenLevel = (gcnew System::Windows::Forms::ToolStripButton());
			this->lbxLevels = (gcnew System::Windows::Forms::ListBox());
			this->rompicker = (gcnew System::Windows::Forms::OpenFileDialog());
			this->rombackup = (gcnew System::Windows::Forms::SaveFileDialog());
			this->toolStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// toolStrip1
			// 
			this->toolStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->btnOpenROM, this->toolStripSeparator1, 
				this->btnOpenLevel});
			this->toolStrip1->Location = System::Drawing::Point(0, 0);
			this->toolStrip1->Name = L"toolStrip1";
			this->toolStrip1->Size = System::Drawing::Size(453, 25);
			this->toolStrip1->TabIndex = 0;
			this->toolStrip1->Text = L"toolStrip1";
			// 
			// btnOpenROM
			// 
			this->btnOpenROM->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnOpenROM->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnOpenROM.Image")));
			this->btnOpenROM->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnOpenROM->Name = L"btnOpenROM";
			this->btnOpenROM->Size = System::Drawing::Size(79, 22);
			this->btnOpenROM->Text = L"Open ROM...";
			this->btnOpenROM->ToolTipText = L"what it says";
			this->btnOpenROM->Click += gcnew System::EventHandler(this, &Form1::btnOpenROM_Click);
			// 
			// toolStripSeparator1
			// 
			this->toolStripSeparator1->Name = L"toolStripSeparator1";
			this->toolStripSeparator1->Size = System::Drawing::Size(6, 25);
			// 
			// btnOpenLevel
			// 
			this->btnOpenLevel->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnOpenLevel->Enabled = false;
			this->btnOpenLevel->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnOpenLevel.Image")));
			this->btnOpenLevel->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnOpenLevel->Name = L"btnOpenLevel";
			this->btnOpenLevel->Size = System::Drawing::Size(67, 22);
			this->btnOpenLevel->Text = L"Open level";
			this->btnOpenLevel->ToolTipText = L"oh yeah let\'s edit that level";
			this->btnOpenLevel->Click += gcnew System::EventHandler(this, &Form1::btnOpenLevel_Click);
			// 
			// lbxLevels
			// 
			this->lbxLevels->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->lbxLevels->FormattingEnabled = true;
			this->lbxLevels->IntegralHeight = false;
			this->lbxLevels->Location = System::Drawing::Point(0, 28);
			this->lbxLevels->Name = L"lbxLevels";
			this->lbxLevels->Size = System::Drawing::Size(453, 403);
			this->lbxLevels->TabIndex = 1;
			this->lbxLevels->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::lbxLevels_SelectedIndexChanged);
			this->lbxLevels->DoubleClick += gcnew System::EventHandler(this, &Form1::lbxLevels_DoubleClick);
			// 
			// rompicker
			// 
			this->rompicker->DefaultExt = L"nds";
			this->rompicker->Filter = L"Nintendo DS ROM|*.nds|Anything|*.*";
			this->rompicker->RestoreDirectory = true;
			// 
			// rombackup
			// 
			this->rombackup->DefaultExt = L"nds";
			this->rombackup->Filter = L"Nintendo DS ROM|*.nds|Anything|*.*";
			this->rombackup->RestoreDirectory = true;
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(453, 430);
			this->Controls->Add(this->lbxLevels);
			this->Controls->Add(this->toolStrip1);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->Name = L"Form1";
			this->Text = L"SM64DS Editor v1.0";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->FormClosed += gcnew System::Windows::Forms::FormClosedEventHandler(this, &Form1::Form1_FormClosed);
			this->toolStrip1->ResumeLayout(false);
			this->toolStrip1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

		String^ m_ROMPath;
		CNitroROM^ m_ROM;

		List<EditorMainForm^>^ m_OpenedEditors;

	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) 
			 {
				 m_ROMPath = "";
				 m_OpenedEditors = gcnew List<EditorMainForm^>();
			 }
private: System::Void btnOpenROM_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 if (rompicker->ShowDialog(this) == Windows::Forms::DialogResult::OK)
			 {
				 if (!File::Exists(rompicker->FileName))
				 {
					 MessageBox::Show("The specified file doesn't exist.", "Error", MessageBoxButtons::OK, MessageBoxIcon::Error);
					 return;
				 }

				 Stream^ fs = File::Open(rompicker->FileName, FileMode::Open, FileAccess::Read);
				 BinaryReader^ br = gcnew BinaryReader(fs, System::Text::Encoding::ASCII);

				 fs->Seek(0, SeekOrigin::Begin);
				 array<wchar_t>^ romtitle = br->ReadChars(12);
				 if (gcnew String(romtitle) != "S.MARIO64DS\0")
				 {
					 MessageBox::Show("The specified file isn't a Super Mario 64 DS ROM.", "Error", MessageBoxButtons::OK, MessageBoxIcon::Error);
					 return;
				 }

				 fs->Seek(12, SeekOrigin::Begin);
				 UInt32 gamecode = br->ReadUInt32();

				 delete br; delete fs;

				 if (m_ROMPath != "")
				 {
					 while (m_OpenedEditors->Count > 0)
						 m_OpenedEditors[m_OpenedEditors->Count - 1]->Close();

					 m_OpenedEditors->Clear();

					 lbxLevels->Items->Clear();
					 delete m_ROM;
				 }

				 m_ROMPath = rompicker->FileName;

				 try { m_ROM = gcnew CNitroROM(m_ROMPath); }
				 catch (Exception^ ex)
				 {
					 MessageBox::Show(String::Format("An error occured while loading the ROM:\n{0}", ex->Message),
						 "Error - SM64DS Editor", MessageBoxButtons::OK, MessageBoxIcon::Error);
					 return;
				 }

				 m_ROM->BeginRW();
				 if (m_ROM->NeedsPatch())
				 {
					 Windows::Forms::DialogResult res = 
						 MessageBox::Show(	"This ROM needs to be patched before the editor can work with it.\n\n"
											"Do you want to first make a backup of it incase the patching\n"
											"operation goes wrong somehow?",
											"SM64DS Editor", MessageBoxButtons::YesNoCancel, MessageBoxIcon::Question);

					 if (res == Windows::Forms::DialogResult::Yes)
					 {
						 for (;;)
						 {
							 if (rombackup->ShowDialog(this) == Windows::Forms::DialogResult::OK)
							 {
								 if (rombackup->FileName == m_ROMPath)
								 {
									 MessageBox::Show("Making a backup of your ROM =/= overwriting it", 
										 "duh", MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
									 continue;
								 }

								 m_ROM->EndRW();
								 File::Copy(m_ROMPath, rombackup->FileName, true);
								 m_ROM->BeginRW();
							 }

							 break;
						 }
					 }
					 else if (res == Windows::Forms::DialogResult::Cancel)
					 {
						 m_ROM->EndRW();
						 delete m_ROM;
						 m_ROMPath = "";
						 return;
					 }

					 m_ROM->Patch();
				 }

				 m_ROM->LoadFileTable();
				 m_ROM->EndRW();

				 for (int i = 0; i < 52; i++)
				 {
					 lbxLevels->Items->Add(gcnew String(g_LevelNames[i]));
				 }
			 }
		 }
private: System::Void Form1_FormClosed(System::Object^  sender, System::Windows::Forms::FormClosedEventArgs^  e) 
		 {
			 delete m_OpenedEditors;

			 if (m_ROMPath != "")
			 {
				 delete m_ROM;
			 }
		 }
private: System::Void lbxLevels_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
			 btnOpenLevel->Enabled = (lbxLevels->SelectedIndex != -1);
		 }

private: void LoadLevel(int id)
		{
			for each (EditorMainForm^ test in m_OpenedEditors)
			{
				if (test->GetLevelID() == id)
				{
					test->Focus();
					return;
				}
			}

			EditorMainForm^ form;
			try { form = gcnew EditorMainForm(m_OpenedEditors, m_ROM, id); }
			catch (Exception^ ex)
			{
				MessageBox::Show(	String::Format("An error occured while loading this level:\nException '{0}'\n\nWhich means you can't edit this level for now.\nBe patient, it will be fixed in a next version.", ex->Message),
									"Oops", MessageBoxButtons::OK, MessageBoxIcon::Error);

				return;
			}

			form->Show();
			m_OpenedEditors->Add(form);
		}

private: System::Void btnOpenLevel_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 LoadLevel(lbxLevels->SelectedIndex);

		 }
private: System::Void lbxLevels_DoubleClick(System::Object^  sender, System::EventArgs^  e)
		 {
			 if (lbxLevels->SelectedIndex != -1)
				 LoadLevel(lbxLevels->SelectedIndex);
		 }
};
}

