#pragma once

public ref class CNitroOverlay: public INitroROMBlock
{
public:
	CNitroOverlay(CNitroROM^ rom, UInt32 ID);
	~CNitroOverlay();

	UInt32 GetRAMAddr() { return m_RAMAddr; }

	void SaveChanges();
	void Update() { m_OVTEntryAddr = m_ROM->GetOverlayEntryOffset(m_ID); }

	CNitroROM^ ROM() { return m_ROM; }

private:
	UInt32 m_ID;
	UInt16 m_FileID;
	UInt32 m_OVTEntryAddr;
	UInt32 m_RAMAddr;

	void Decompress(array<Byte>^% data);
};
