#pragma once

public ref class CEditorFormList
{
public:
	CEditorFormList() 
	{
		m_FormList = gcnew System::Collections::Generic::List<EditorMainForm^>();
	}

	~CEditorFormList()
	{
		for each (EditorMainForm^ emf in m_FormList)
		{
			emf->Close();
			delete emf;
		}

		delete m_FormList;
	}

	void AddForm(EditorMainForm^ form)
	{
		m_FormList->Add(form);
	}

	void RemoveForm(EditorMainForm^ form)
	{
		int idx = m_FormList->BinarySearch(form);
		delete m_FormList[idx];
		m_FormList->RemoveAt(idx);
	}

private:
	System::Collections::Generic::List<EditorMainForm^>^ m_FormList;
};
